## ros-humble-grid-map-pcl 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(grid_map_pcl)

## Find ament macros and libraries
find_package(ament_cmake REQUIRED)
find_package(grid_map_cmake_helpers REQUIRED)
find_package(grid_map_core REQUIRED)
find_package(grid_map_msgs REQUIRED)
find_package(grid_map_ros REQUIRED)
find_package(PCL REQUIRED) ## See ROS REP2000 for expected PCL version
find_package(rclcpp REQUIRED)
find_package(rcutils REQUIRED)

find_package(OpenMP QUIET)
if(OpenMP_FOUND)
  add_compile_options("${OpenMP_CXX_FLAGS}")
  add_definitions(-DGRID_MAP_PCL_OPENMP_FOUND=${OpenMP_FOUND})
endif()

# Add links to PCL definitons and directories
include_directories(${PCL_INCLUDE_DIRS})
link_directories(${PCL_LIBRARY_DIRS})
add_definitions(${PCL_DEFINITIONS})

grid_map_package()

set(SRC_FILES
  src/GridMapPclLoader.cpp
  src/PclLoaderParameters.cpp
  src/PointcloudProcessor.cpp
  src/helpers.cpp
  src/GridMapPclConverter.cpp
)

set(dependencies
  grid_map_core
  grid_map_msgs
  grid_map_ros
  rclcpp
  rcutils
)

###########
## Build ##
###########

## Specify additional locations of header files
include_directories(
  include
  SYSTEM
    ${EIGEN3_INCLUDE_DIR}
    ${OpenMP_CXX_INCLUDE_DIRS}
)

## Declare a cpp library
add_library(${PROJECT_NAME} SHARED
  ${SRC_FILES}
)

target_link_libraries(${PROJECT_NAME}
  ${OpenMP_CXX_LIBRARIES}
  ${PCL_LIBRARIES}
  yaml-cpp
)

ament_target_dependencies(${PROJECT_NAME} SYSTEM
  ${dependencies}
)

add_executable(grid_map_pcl_loader_node
  src/grid_map_pcl_loader_node.cpp
)

target_link_libraries(grid_map_pcl_loader_node
  ${PROJECT_NAME}
  ${OpenMP_CXX_LIBRARIES}
)

ament_target_dependencies(${PROJECT_NAME}
  ${dependencies}
)

#############
## Install ##
#############

# Mark executables and/or libraries for installation
install(
  TARGETS
    ${PROJECT_NAME}
    grid_map_pcl_loader_node
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION lib/${PROJECT_NAME}
)

# Mark cpp header files for installation
install(
  DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME}
  FILES_MATCHING PATTERN "*.hpp"
)

install(
  DIRECTORY
    config
    launch
  DESTINATION share/${PROJECT_NAME}
)

#############
## Testing ##
#############

if(BUILD_TESTING)
  # Linting is setup this way to add a filter
  # to ament_cpplint to ignore the lack of
  # copyright messages at the top of files.
  # Copyright messages are being checked for by both
  # ament_cmake_cpplint & ament_cmake_copyright.

  find_package(ament_lint_auto REQUIRED)
  find_package(ament_lint_auto QUIET)
  if(ament_lint_auto_FOUND)
    # exclude copyright checks
    list(APPEND AMENT_LINT_AUTO_EXCLUDE
      ament_cmake_cpplint
      ament_cmake_copyright
    )
    ament_lint_auto_find_test_dependencies()

    # run cpplint without copyright filter
    find_package(ament_cmake_cpplint)
    ament_cpplint(
      FILTERS -legal/copyright -build/include_order
    )
  endif()
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_gtest REQUIRED)

  # Adding test data to the package share directory
  install(
    DIRECTORY test/test_data/
    DESTINATION share/${PROJECT_NAME}/test_data/
  )

  ## Add gtest based cpp test target and link libraries
  ament_add_gtest(${PROJECT_NAME}-test
    test/GridMapPclLoaderTest.cpp
    test/HelpersTest.cpp
    test/PointcloudCreator.cpp
    test/PointcloudProcessorTest.cpp
    test/test_helpers.cpp
    test/test_grid_map_pcl.cpp
    TIMEOUT 300
  )
endif()

if(TARGET ${PROJECT_NAME}-test)
  target_link_libraries(${PROJECT_NAME}-test
    ${PROJECT_NAME}
  )
endif()

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME})
ament_package()

=== debian/changelog ===
ros-humble-grid-map-pcl (2.0.0-3bookworm) bookworm; urgency=high

  * ci: fix tests in grid map pcl
  * fix: mark Eigen library as SYSTEM
  * fix: build error on jammy
  * Add height of cluster with the most points method
  * Initial ROS2 port
  * Contributors: Maximilian Wulf, Steve Macenski

 -- Maximilian Wulf <mwulf@anybotics.com>  Mon, 12 Sep 2022 16:00:00 -0000

ros-humble-grid-map-pcl (1.6.2-3bookworm) bookworm; urgency=high



 -- Maximilian Wulf <mwulf@anybotics.com>  Sun, 13 Oct 2019 16:00:00 -0000

ros-humble-grid-map-pcl (1.6.1-3bookworm) bookworm; urgency=high

  * Updated host changes.
  * Updated author e-mail address.
  * Contributors: Peter Fankhauser, Péter Fankhauser

 -- Maximilian Wulf <mwulf@anybotics.com>  Tue, 26 Feb 2019 16:00:00 -0000

ros-humble-grid-map-pcl (1.6.0-3bookworm) bookworm; urgency=high



 -- Maximilian Wulf <mwulf@anybotics.com>  Thu, 23 Nov 2017 16:00:00 -0000

ros-humble-grid-map-pcl (1.5.2-3bookworm) bookworm; urgency=high



 -- Maximilian Wulf <mwulf@anybotics.com>  Mon, 24 Jul 2017 16:00:00 -0000

ros-humble-grid-map-pcl (1.5.1-3bookworm) bookworm; urgency=high



 -- Maximilian Wulf <mwulf@anybotics.com>  Mon, 24 Jul 2017 16:00:00 -0000

ros-humble-grid-map-pcl (1.5.0-3bookworm) bookworm; urgency=high

  * Improved efficiency of mesh conversion.
  * Contributors: Alex Millane

 -- Maximilian Wulf <mwulf@anybotics.com>  Mon, 17 Jul 2017 16:00:00 -0000

ros-humble-grid-map-pcl (1.4.2-3bookworm) bookworm; urgency=high

  * Addressing C++ compiler warnings.
  * Contributors: Peter Fankhauser

 -- Maximilian Wulf <mwulf@anybotics.com>  Mon, 23 Jan 2017 16:00:00 -0000

ros-humble-grid-map-pcl (1.4.1-3bookworm) bookworm; urgency=high

  * Added new grid_map_pcl package to convert from PCL mesh to grid map.
  * Contributors: Dominic Jud

 -- Maximilian Wulf <mwulf@anybotics.com>  Sat, 22 Oct 2016 16:00:00 -0000

=== debian/control ===
Source: ros-humble-grid-map-pcl
Section: misc
Priority: optional
Maintainer: Maximilian Wulf <mwulf@anybotics.com>
Build-Depends: debhelper (>= 9.0.0), libpcl-dev, libyaml-cpp-dev, ros-humble-ament-cmake, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-grid-map-cmake-helpers, ros-humble-grid-map-core, ros-humble-grid-map-msgs, ros-humble-grid-map-ros, ros-humble-rclcpp, ros-humble-rcutils, ros-humble-ros-workspace
Homepage: http://github.com/anybotics/grid_map
Standards-Version: 3.9.2

Package: ros-humble-grid-map-pcl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpcl-dev, libyaml-cpp-dev, ros-humble-grid-map-core, ros-humble-grid-map-msgs, ros-humble-grid-map-ros, ros-humble-rclcpp, ros-humble-rcutils, ros-humble-ros-workspace
Description: Conversions between grid maps and Point Cloud Library (PCL) types.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG -O0
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-grid-map-pcl//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-grid-map-pcl//opt/ros/humble/opt/grid_map_pcl/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
